export const median = (values: number[]) => {
  if (values.length === 0) return;

  values.sort(function (a, b) {
    return a - b;
  });

  var half = Math.floor(values.length / 2);

  if (values.length % 2) return values[half];

  return (values[half - 1] + values[half]) / 2.0;
};

export const stdDeviation = (array: number[]) => {
  if (array.length === 0) return;
  const n = array.length;
  const mean = array.reduce((a, b) => a + b) / n;
  return Math.sqrt(array.map((x) => Math.pow(x - mean, 2)).reduce((a, b) => a + b) / n);
};

export const getVo2max = (beepTest: number): number => {
  if (beepTest > 4 || beepTest < 15.14) {
    const data = {
      '4.01': 27.0,
      '4.02': 27.4,
      '4.03': 27.8,
      '4.04': 28.1,
      '4.05': 28.4,
      '4.06': 28.8,
      '4.07': 29.1,
      '4.08': 29.5,
      '4.09': 29.8,
      '5.01': 30.2,
      '5.02': 30.5,
      '5.03': 30.9,
      '5.04': 31.2,
      '5.05': 31.6,
      '5.06': 31.9,
      '5.07': 32.2,
      '5.08': 32.6,
      '5.09': 32.9,
      '6.01': 33.3,
      '6.02': 33.6,
      '6.03': 33.9,
      '6.04': 34.3,
      '6.05': 34.6,
      '6.06': 34.9,
      '6.07': 35.3,
      '6.08': 35.6,
      '6.09': 36.0,
      '6.10': 36.3,
      '7.01': 36.6,
      '7.02': 37.0,
      '7.03': 37.3,
      '7.04': 37.6,
      '7.05': 37.9,
      '7.06': 38.3,
      '7.07': 38.6,
      '7.08': 38.9,
      '7.09': 39.3,
      '7.10': 39.6,
      '8.01': 39.9,
      '8.02': 40.2,
      '8.03': 40.6,
      '8.04': 40.9,
      '8.05': 41.2,
      '8.06': 41.5,
      '8.07': 41.8,
      '8.08': 42.2,
      '8.09': 42.5,
      '8.10': 42.8,
      '8.11': 43.1,
      '9.01': 43.4,
      '9.02': 43.8,
      '9.03': 44.1,
      '9.04': 44.4,
      '9.05': 44.7,
      '9.06': 45.0,
      '9.07': 45.3,
      '9.08': 45.6,
      '9.09': 46.0,
      '9.10': 46.3,
      '9.11': 46.6,
      '10.01': 46.8,
      '10.02': 47.1,
      '10.03': 47.5,
      '10.04': 47.8,
      '10.05': 48.1,
      '10.06': 48.4,
      '10.07': 48.7,
      '10.08': 49.0,
      '10.09': 49.3,
      '10.10': 49.6,
      '10.11': 50.0,
      '11.01': 50.2,
      '11.02': 50.6,
      '11.03': 50.9,
      '11.04': 51.2,
      '11.05': 51.5,
      '11.06': 51.8,
      '11.07': 52.1,
      '11.08': 52.4,
      '11.09': 52.7,
      '11.10': 53.0,
      '11.11': 53.3,
      '11.12': 53.5,
      '12.01': 53.6,
      '12.02': 53.9,
      '12.03': 54.2,
      '12.04': 54.5,
      '12.05': 54.8,
      '12.06': 55.1,
      '12.07': 55.4,
      '12.08': 55.7,
      '12.09': 56.0,
      '12.10': 56.3,
      '12.11': 56.7,
      '12.12': 57.0,
      '13.01': 57.3,
      '13.02': 57.6,
      '13.03': 57.9,
      '13.04': 58.1,
      '13.05': 58.4,
      '13.06': 58.7,
      '13.07': 59.0,
      '13.08': 59.3,
      '13.09': 59.6,
      '13.10': 59.8,
      '13.11': 60.1,
      '13.12': 60.4,
      '13.13': 60.7,
      '14.01': 60.9,
      '14.02': 61.2,
      '14.03': 61.5,
      '14.04': 61.8,
      '14.05': 62.0,
      '14.06': 62.3,
      '14.07': 62.6,
      '14.08': 62.9,
      '14.09': 63.1,
      '14.10': 63.4,
      '14.11': 63.7,
      '14.12': 63.9,
      '14.13': 64.2,
      '15.01': 64.5,
      '15.02': 64.7,
      '15.03': 65.0,
      '15.04': 65.3,
      '15.05': 65.5,
      '15.06': 65.8,
      '15.07': 66.1,
      '15.08': 66.3,
      '15.09': 66.6,
      '15.10': 66.8,
      '15.11': 67.1,
      '15.12': 67.4,
      '15.13': 67.6,
    };

    return data[beepTest];
  }
  return 0;
};
